#ifndef NEWKEY_H
#define NEWKEY_H
#include "common.h"
#include "Entry.h"

/**
 * This Entry records the abort sent by a given machine.
 * @author Ali Younis <ayounis@uci.edu>
 * @version 1.0
 */


class NewKey : public Entry {
private:
	IoTString *key;
	int64_t machineid;


public:
	NewKey(Slot *slot, IoTString *_key, int64_t _machineid) :
		Entry(slot),
		key(_key),
		machineid(_machineid) {
	}

	int64_t getMachineID() { return machineid; }
	IoTString *getKey() { return key; }
	void setSlot(Slot *s) { parentslot = s; }


	void encode(ByteBuffer *bb);
	int getSize();
	char getType() { return TypeNewKey; }

	Entry *getCopy(Slot *s) { return new NewKey(s, key, machineid); }
};

Entry *NewKey_decode(Slot *slot, ByteBuffer *bb);

#endif
